﻿using Microsoft.VisualStudio.Shell;
using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace TestProject
{
    /// <summary>
    /// 테스트 프로젝트 패키지
    /// </summary>
    [PackageRegistration(UseManagedResourcesOnly = true, AllowsBackgroundLoading = true)]
    [Guid(TestProjectPackage.PackageGUIDString)]
    [ProvideMenuResource("Menus.ctmenu", 1)]
    public sealed class TestProjectPackage : AsyncPackage
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 패키지 GUID 문자열
        /// </summary>
        public const string PackageGUIDString = "06A361EF-CA91-46BC-97A1-CCC7C20AB1E9";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 초기화하기 (비동기) - InitializeAsync(cancellationToken, progress)

        /// <summary>
        /// 초기화하기 (비동기)
        /// </summary>
        /// <param name="cancellationToken">취소 토큰</param>
        /// <param name="progress">진행 인터페이스</param>
        /// <returns>태스크</returns>
        protected override async System.Threading.Tasks.Task InitializeAsync(CancellationToken cancellationToken, IProgress<ServiceProgressData> progress)
        {
            await JoinableTaskFactory.SwitchToMainThreadAsync(cancellationToken);

            await TestCommand.InitializeAsync(this);
        }

        #endregion
    }
}